
/* Chrysalide - Outil d'analyse de fichiers binaires
 * space-int.h - prototypes internes pour la définition d'un espace de noms pour les fonctions de scan
 *
 * Copyright (C) 2022 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PLUGINS_KAITAI_ROST_SPACE_INT_H
#define _PLUGINS_KAITAI_ROST_SPACE_INT_H


#include "space.h"


#include <analysis/scan/space-int.h>



/* Espace de noms avec chargement dynamique de définitions Kaitai (instance) */
struct _GKaitaiNamespace
{
    GScanNamespace parent;                  /* A laisser en premier        */

};

/* Espace de noms avec chargement dynamique de définitions Kaitai (classe) */
struct _GKaitaiNamespaceClass
{
    GScanNamespaceClass parent;             /* A laisser en premier        */

};


/* Met en place un nouvel espace de noms pour scan. */
bool g_kaitai_namespace_create(GKaitaiNamespace *);



#endif  /* _PLUGINS_KAITAI_ROST_SPACE_INT_H */
