
/* Chrysalide - Outil d'analyse de fichiers binaires
 * file-int.h - prototypes internes pour le chargement de données binaires à partir d'un fichier
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_CONTENTS_FILE_INT_H
#define _ANALYSIS_CONTENTS_FILE_INT_H


#include "file.h"


#include "memory-int.h"



/* Contenu de données binaires issues d'un fichier (instance) */
struct _GFileContent
{
    GMemoryContent parent;                  /* A laisser en premier        */

    char *filename;                         /* Fichier chargé en mémoire   */
    int fd;                                 /* Flux ouvert en lectureu     */

};

/* Contenu de données binaires issues d'un fichier (classe) */
struct _GFileContentClass
{
    GMemoryContentClass parent;             /* A laisser en premier        */

};


/* Met en place un contenu d'un fichier donné. */
bool g_file_content_create(GFileContent *, const char *);



#endif  /* _ANALYSIS_CONTENTS_FILE_INT_H */
