
/* Chrysalide - Outil d'analyse de fichiers binaires
 * customizer.h - prototypes pour la modification paramétrée d'une séquence d'octets
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_CUSTOMIZER_H
#define _ANALYSIS_SCAN_CUSTOMIZER_H


#include <glib-object.h>
#include <stdbool.h>


#include "modifier.h"



#define G_TYPE_SCAN_TOKEN_CUSTOMIZER            g_scan_token_customizer_get_type()
#define G_SCAN_TOKEN_CUSTOMIZER(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_SCAN_TOKEN_CUSTOMIZER, GScanTokenCustomizer))
#define G_IS_SCAN_TOKEN_CUSTOMIZER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_SCAN_TOKEN_CUSTOMIZER))
#define G_SCAN_TOKEN_CUSTOMIZER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_SCAN_TOKEN_CUSTOMIZER, GScanTokenCustomizerClass))
#define G_IS_SCAN_TOKEN_CUSTOMIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_SCAN_TOKEN_CUSTOMIZER))
#define G_SCAN_TOKEN_CUSTOMIZER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_SCAN_TOKEN_CUSTOMIZER, GScanTokenCustomizerClass))


/* Encadrement de transformation paramétrée d'une séquence d'octets (instance) */
typedef struct _GScanTokenCustomizer GScanTokenCustomizer;

/* Encadrement de transformation paramétrée d'une séquence d'octets (classe) */
typedef struct _GScanTokenCustomizerClass GScanTokenCustomizerClass;


/* Indique le type défini pour une transformation personnalisée d'une séquence d'octets. */
GType g_scan_token_customizer_get_type(void);

/* Construit un encadrement de transformation de motifs. */
GScanTokenModifier *g_scan_token_customizer_new(const modifier_arg_t *);

/* Ajoute un argument à l'encadrement de transformation. */
void g_scan_token_customizer_add_extra_arg(GScanTokenCustomizer *, const modifier_arg_t *);

/* Définit le transformateur effectif pour les motifs. */
bool g_scan_token_customizer_attach_modifier(GScanTokenCustomizer *, GScanTokenModifier *);



#endif  /* _ANALYSIS_SCAN_CUSTOMIZER_H */
