#!/bin/bash

if [ -z "$FUZ_OUT" ]; then
    echo "$0 needs a \$FUZ_OUT environment variable!"
    exit 1
fi


SCRIPT_DIR=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )

MIN_DIR="$SCRIPT_DIR/min"


mkdir -p "$MIN_DIR"

find "$FUZ_OUT/default/crashes/" -name 'id*' | while read f;
do

    id=$( echo $f | cut -d: -f2 | cut -d, -f1 )

    h=$( sha256sum $f | cut -d " " -f1 )

    afl-tmin -i "$f"  -o "$MIN_DIR/$id-$h.rost" -- /dev/shm/fuzzing-sys/bin/fast-rost /bin/ls

done
